﻿using Roslyn.Compilers;
using Roslyn.Compilers.Common;
using Roslyn.Compilers.CSharp;
using Roslyn.Services;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace FindingDateTimeNow
{
	public sealed class ChangeDateTimeKindToUtcCodeAction
		: ICodeAction
	{
		private IDocument document;
		private ArgumentSyntax argumentNode;

		public ChangeDateTimeKindToUtcCodeAction(IDocument document, ArgumentSyntax argumentNode)
		{
			this.document = document;
			this.argumentNode = argumentNode;
		}

		public string Description
		{
			get { return "Change DateTimeKind to Utc"; }
		}

		public CodeActionEdit GetEdit(CancellationToken cancellationToken)
		{
			var currentKindNode = (this.argumentNode.Expression as MemberAccessExpressionSyntax).Name;
			var utcNode = Syntax.IdentifierName("Utc");
			var rootNode = this.document.GetSyntaxRoot(cancellationToken);
			var newRootNode = rootNode.ReplaceNode(currentKindNode, utcNode);
			return new CodeActionEdit(document.UpdateSyntaxRoot(newRootNode));
		}
	}
}
